/*
 * myuart.c
 *
 *  Created on: 24-06-2013
 *      Author: admin
 */
#include "avr/io.h"
#include <avr/pgmspace.h>
#include <stdlib.h>

#include "myuart.h"



void uart_init( uint16_t ubrr ) {
	/* Set baud rate */
	UBRRH = (uint8_t)(ubrr>>8);
	UBRRL = (uint8_t)ubrr;
	/* Enable transmitter */
	UCSRB = (1<<TXEN);

}



void uart_putc( char data ) {
	/* Wait for empty transmit buffer */
	while ( !( UCSRA & (1<<UDRE)) );
	/* Put data into buffer, sends the data */
	UDR = data;
}


void uart_puts( char * s ) {
	while( *s ) uart_putc( *s++ );
}


void uart_puts_P(const char *s)		// wysya acuch z pamici RAM na UART
{
  register char c;
  while ((c = pgm_read_byte( s++) )) uart_putc(c);			// dopki nie napotkasz 0 wysyaj znak
}


void uart_putlong( uint32_t liczba, uint8_t radix ) {
	char buf[17];
	ltoa( liczba, buf, radix );
	uart_puts( buf );
}



